/*
 * Presenter Club - Make Great Presentations, Faster
 * Copyright (C) 2016 Sam Parkinson <sam@sam.today>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

@keyframes Loader--fast-slide {
    0%   { transform: translateX(-25%); opacity: 0; }
    50%  { transform: none;             opacity: 1; }
    100% { transform: translateX(25%);  opacity: 0; }
}
@keyframes Loader--colors {
    0%   { background: _palette(colors, red); }
    25%  { background: _palette(colors, lime); }
    50%  { background: _palette(colors, lime); }
    75%  { background: _palette(colors, green); }
    100% { background: _palette(colors, orange); }
}
@keyframes Loader--colors-alternate {
    0%   { background: _palette(colors, blue); }
    25%  { background: _palette(colors, green); }
    50%  { background: _palette(colors, blue); }
    75%  { background: _palette(colors, green); }
    100% { background: _palette(colors, blue); }
}
$loader-width:  192px / 2;
$loader-height: 108px / 2;
$loader-duration: 1.5s;

.Loader {
    box-sizing: initial;
    display: block;
    width: $loader-width;
    height: $loader-height;
    border: $loader-height/10 solid _palette(border);
    border-radius: $loader-height/10;
    background: _palette(border-bg);

    margin: 1em auto;

    &:before,
    &:after {
        display: block;
        width: $loader-width;
        height: $loader-height;

        font-family: _font(family-heading);
        font-weight: _font(weight-heading-bold);
        font-size: $loader-height/1.75;
        color: white;
        text-align: center;
    }

    &:before {
        content: 'P';
        opacity: 1;
        animation: Loader--fast-slide
                        $loader-duration
                        ($loader-duration/2)
                        infinite
                        ease-in-out,
                   Loader--colors ($loader-duration * 5) steps(5) infinite;
    }

    &:after {
        content: 'C';
        margin-top: -$loader-height;
        animation: Loader--fast-slide $loader-duration infinite ease-in-out,
                   Loader--colors-alternate
                        ($loader-duration * 5)
                        steps(5)
                        infinite;
    }
}

.LoaderProgress {
    margin: 1em auto;
    transition: all _duration(transition) ease-in-out;
    width: ($loader-width + $loader-height * 0.2);
}
.LoaderProgress__normal,
.LoaderProgress__insert {
    display: block;
    width: ($loader-width + $loader-height * 0.2);
    height: ($loader-height * 1.2);
    border: $loader-height/10 solid _palette(border);
    border-radius: $loader-height/10;
    background: _palette(border-bg);

    font-weight: bold;
    overflow: hidden;
}
.LoaderProgress--3digit {
    font-size: 1.5em;
}
.LoaderProgress--2digit {
    font-size: 1.8em;
}
.LoaderProgress--1digit {
    font-size: 2em;
}

.LoaderProgress__insert {
    margin-top: ($loader-height * -1.2);

    background: black;
    border-color: transparent;
    border-right: 0;
    color: white;
}
